package com.fuzamei.service;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fuzamei.dao.CapitalTransferDao;
import com.fuzamei.entity.CapitalTransfer;
import com.fuzamei.utils.PageDTO;

@Service
public class CapitalTransferService {
    @Autowired
    private   CapitalTransferDao  capitalTransferDao;
    private static final int ROW_NUM = 10; // 分页每页显示数据的数量
    /**  
     *  查询资金划转表  省分行托管中心指令业务岗
     * @param  
     * @param   
     * @throws Exception  
     */
	public PageDTO selectCapitalTransferTable(Map<String, Object> map){//查询资金划转列表
		int page = 1; // 默认页是第一页
		String fund_name="";//基金名称
		String status_name="";//状态
		long startTime = 0; // 开始时间默认0
		long endTime = Long.MAX_VALUE; // 结束时间默认Long最大值

		if (!"".equals(map.get("page")) && map.get("page") != null) { // 等于空就直接取第一页
			try {
				page = Integer.parseInt((String) map.get("page"));
				if (page < 1) {
					page = 1;
				}
			} catch (NumberFormatException e) {
				page = 1; // 数据解析异常page还是1
			}
		}
		if (!"".equals(map.get("fund_name")) && map.get("fund_name") != null) { // 等于空就直接取空值
			fund_name = (String) map.get("fund_name");
		}
		if (!"".equals(map.get("status_name")) && map.get("status_name") != null) { // 等于空就直接取空值
			status_name = (String) map.get("status_name");
		}
		if (!"".equals(map.get("startTime")) && map.get("startTime") != null) { // 等于空就直接取空值
			try {
				startTime = Long.parseLong((String) map.get("startTime"));
			} catch (NumberFormatException e) {
				startTime = 0; // 数据解析异常startTime还是0
			}
		}
		if (!"".equals(map.get("endTime")) && map.get("endTime") != null) { // 等于空就直接取空值
			try {
				endTime = Long.parseLong((String) map.get("endTime"));
			} catch (NumberFormatException e) {
				endTime = Long.MAX_VALUE; // 数据解析异常endTime还是9223372036854775807L
			}
		}
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		mapToDao.put("startPage", (page - 1) * ROW_NUM);
		mapToDao.put("fund_name", fund_name);
		mapToDao.put("status_name", status_name);
		if (startTime <= endTime) {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", endTime);
		} else {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", Long.MAX_VALUE);
		}
		mapToDao.put("rowNum", ROW_NUM); // 默认每页显示数据是10条，可根据需求修改分页数量
		int  countPage=capitalTransferDao.selectCapitalTransferPage();//资金划转表  总页数
		List<CapitalTransfer> list=capitalTransferDao.selectCapitalTransferTable(mapToDao);
		pageDto.setTotal(countPage);
		pageDto.setRows(list);
		return pageDto;
		
	}
	
}
